<?php
header ('Content-type: application/json; charset=utf-8');
require_once dirname(__FILE__) . '/../../config/config.inc.php';
require_once dirname(__FILE__) . '/../../init.php';

if(!defined('_PS_VERSION_'))
{
	exit;
}

$body = Tools::file_get_contents('php://input');
$event = Tools::jsonDecode($body);

$order_id = $event->order_id;
$paid_at = $event->paid_at;
$charge = $event->charge;
$payment_method = $event->payment_method;

$orden = new Order($order_id);
	
if (Validate::isLoadedObject($orden))
{
	if($payment_method === "paycash")
	{
		$idEstadoCompletado = 2;
		
		$state = new OrderState($idEstadoCompletado);
		$enviarEmailAutomatico = $state->send_email;
		
		$history  = new OrderHistory();
        $history->id_order = (int)$orden->id;
        $history->changeIdOrderState((int) $idEstadoCompletado, $orden->id);
		$history->addWithemail();
        $history->save();
		
		$idCustomer = $orden->id_customer;
		$customer = new Customer($idCustomer);
		$email = $customer->email;
		$customerFirstName = $customer->firstname;
		$customerLastName = $customer->lastname;
		
		$ordenReference = $orden->reference;
		
		$emailAdmin = Configuration::get('PS_SHOP_EMAIL');
		
		Mail::Send(
			(int)(Configuration::get('PS_LANG_DEFAULT')),
			'paycash_pago',
			Mail::l('Pago aceptado por PayCash del pedido '.$ordenReference),
			array
			(
				'{firstname}' => Tools::nl2br(''),
				'{lastname}' => Tools::nl2br(''),
				'{pedido}' => Tools::nl2br($ordenReference),
				'{titulo}' => Tools::nl2br('Se ha efectuado el pago del pedido <span class="label" style="font-weight: 700;">'.$ordenReference.'</span>.')
			),
			$emailAdmin, //Email destinatario
			null, //Nombre destinatario
			null, //Email Remitente
			null //Nombre Remitente
		);
		
		$errorBD = '';
		try
		{
			$guardarBD = actualizarInformacionOrden($orden->id, $paid_at, $charge, $payment_method);
		}
		catch(Exception $e)
		{
			$errorBD = ' Error al guardar en base de datos: '.$e->getMessage();
		}
		
		if($enviarEmailAutomatico)	
			echo json_encode(array("Codigo" => 1, "Mensaje" => "Pago aplicado al pedido y notificaciones enviadas por correo electrónico al cliente ".$email." y al administrador ".$emailAdmin.$errorBD));
		else
			echo json_encode(array("Codigo" => 1, "Mensaje" => "Pago aplicado al pedido y notificaciones enviadas por correo electrónico al administrador ".$emailAdmin.". No se envió notificación al cliente porque el nuevo estado del pedido está configurado para no enviar notificación automáticamente.".$errorBD));
	}
}
else
{
	echo json_encode(array("Codigo" => -1, "Mensaje" => "No existe ningún pedido con el ID ".$order_id));
}

function actualizarInformacionOrden($idOrden, $paid_at, $charge, $payment_method)
{
	return Db::getInstance()->Execute
	(
		'UPDATE '._DB_PREFIX_.'paycash_orden_informacion SET paid_at = "'.pSQL($paid_at).'", charge = "'.pSQL($charge).'", payment_method = "'.pSQL($payment_method).'" WHERE id_orden = '.pSQL((int)$idOrden).';'
	);
}

header('HTTP/1.1 200 OK');
exit;