<?php
class PayCashPrestashopValidationModuleFrontController extends ModuleFrontController
{
    public function postProcess()
    {
        $cart = $this->context->cart;
        $authorized = false;
 
        if (!$this->module->active || $cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0) 
		{
            Tools::redirect('index.php?controller=order&step=1');
        }
 
        foreach (Module::getPaymentModules() as $module)
		{
            if ($module['name'] == 'PayCashPrestashop')
			{
                $authorized = true;
                break;
            }
        }
 
        if (!$authorized)
		{
            die($this->l('Este método de pago no está disponible.'));
        }
 
        $customer = new Customer($cart->id_customer);
 
        if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }
 
		$mensaje = $this->l('PAYCASH DETALLE:')
		. "\n\n" . $this->l('Amount:');
 
        /*$this->module->validateOrder(
            (int) $this->context->cart->id,
            Configuration::get('PS_OS_PAYCASH_EN_ESPERA_PAGO'),
            (float) $this->context->cart->getOrderTotal(true, Cart::BOTH),
            $this->displayName,//$this->module->displayName,
            $mensaje,
            array(),//array('variable' => $this->currentOrder),
            null,(int) $this->context->currency->id,
            false,
            $customer->secure_key
        );*/

		$this->module->validateOrder(
            (int) $this->context->cart->id,
            Configuration::get('PS_OS_PAYCASH_EN_ESPERA_PAGO'),
            (float) $this->context->cart->getOrderTotal(true, Cart::BOTH),
            $this->module->displayName,
            null,
            array(),
            null,
            false,
            $this->context->customer->secure_key
        );
		
        Tools::redirect('index.php?controller=order-confirmation&id_cart='.(int)$cart->id.'&id_module='.(int)$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
    }
}